SWAPON(8)

NAZWA
swapon, swapoff - włącza/wyłącza urządzenia oraz pliki stronicowania i wymiany

SKŁADNIA
swapon [opcje] [plik-specjalny...]
swapoff [-va] [plik-specjalny...]

OPIS
Polecenie swapon jest używane do określania urządzeń do stronicowania i wymiany.

Urządzenie lub plik może być podany za pomocą parametru plik-specjalny. Może mieć on postać -L etykieta lub -U uuid, aby określić urządzenie za pomocą etykiety lub uuid (unikatowego identyfikatora).

Odwołanie do swapon normalnie powinno się pojawiać w systemowych skryptach uruchomieniowych, udostępniając wszystkie urządzenia wymiany, dzięki czemu stronicowanie i wymiana jest rozłożone między wiele urządzeń i plików.

Polecenie swapoff wyłącza wymianę na podanych urządzeniach i plikach. Jeśli użyto opcji -a, to swap jest wyłączany na wszystkich znanych urządzeniach i plikach wymiany (zgodnie z plikiem /proc/swaps lub /etc/fstab).

OPCJE

-a, --all
    Udostępnia wszystkie urządzenia oznaczone jako "swap" w pliku /etc/fstab, z wyjątkiem plików z opcją "noauto". Urządzenia, które są już używane jako swap, są po cichu pomijane.

-d, --discard[=tryb]
    Włącza odrzucanie (discard), jeśli urządzenie, na którym jest swap, pozwala na operacje discard lub trim. Może to pozytywnie wpłynąć na wydajność na niektórych dyskach półprzewodnikowych, ale często tak nie jest. Opcja pozwala na wybór spośród dwóch dostępnych trybów odrzucania: --discard=once do przeprowadzania pojedynczych operacji odrzucania całej przestrzeni wymiany lub --discard=pages do asynchronicznego odrzucania zwolnionych stron wymiany przed udostępnieniem ich do ponownego użycia. Jeśli nie wybierze się żadnego z tych trybów, to domyślnym zachowaniem jest włączenie ich obu. Można również włączyć odrzucanie w /etc/fstab za pomocą opcji montowania discard, discard=once lub discard=pages.

-e, --ifexists
    Pomija po cichu nieistniejące urządzenia. Opcja montowania nofail w /etc/fstab może być również użyta do pomijania nieistniejących urządzeń.

-f, --fixpgsz
    Ponownie inicjuje przestrzeń swap (exec mkswap), jeśli rozmiar strony nie pasuje do rozmiaru podawanego przez obecnie uruchomione jądro. Polecenie mkswap(2) inicjuje całe urządzenie i nie sprawdza go pod kątem błędnych bloków.

-h, --help
    Wyświetla tekst pomocy i wychodzi.

-L etykieta
    Używa partycji z określoną etykietą (potrzebny jest w tym celu dostęp do /proc/partitions).

-o, --options opcje
    Podaje opcje swap jako rozdzielona przecinkami lista zgodna z formatem fstab. Na przykład:

        swapon -o pri=1,discard=pages,nofail /dev/sda2

    Łańcuch opts jest przetwarzany ostatni i nadpisuje wszystkie inne opcje linii poleceń.

-p, --priority priorytet
    Określa priorytet urządzenia wymiany. Priorytet jest wartością z przedziału pomiędzy -1 a 32767. Wyższa liczba oznacza wyższy priorytet. Podręcznik polecenia swapon(2) zawiera pełny opis priorytetów swap. Do pliku /etc/fstab można dodać opcję pri=wartość, która będzie używana ze swapon -a. Jeśli nie zdefiniowano priorytetu,to wartością domyślną jest -1.

-s, --summary
    Wyświetla podsumowanie użycia swapu wg urządzenia. Jest to odpowiednik "cat /proc/swaps". Opcja jest niedostępna w przypadku Linuksa starszego niż 2.1.25. Ten format wyjścia jest PRZESTARZAŁY. Zalecany format --show dostarcza większej kontroli nad danymi wyjściowymi.

--show[=kolumna...]
    Wyświetla możliwą do zdefiniowania tabelę obszarów swap. Lista dostępnych kolumn można znaleźć w wyjściu opcji --help.

--noheadings
    Nie wyświetla nagłówków w wyjściu opcji --show.

--raw
    Nie wyrównuje kolumn tabeli wyświetlanej przez --show.

--bytes
    Opcja --show wyświetla rozmiar przestrzeni wymiany w bajtach, a nie w jednostkach czytelnych dla użytkownika.

-U uuid
    Używa partycji o określonym uuid (unikalnym identyfikatorze).

-v, --verbose
    Więcej szczegółów.

-V, --version
    Wypisuje informację o wersji programu i kończy działanie.

UWAGI
Nie powinno się używać swapon na pliku z dziurami (tzw. rzadki plik). Jeśli jednak tak się stanie, to do logu systemu zostanie dodany komunikat

    swapon: swapfile has holes.

Implementacja pliku wymiany w jądrze spodziewa się możliwości bezpośrednich zapisów do pliku, to jest bez pośrednictwa systemu plików. Stanowi to problem na prealokowanych plikach (np. fallocate(1)) na systemach plików takich jak XFS lub ext4 oraz na systemach plików copy-on-write, takich jak btrfs.

W celu uniknięcia dziur w XFS i ext4 zaleca się używanie dd(1) i /dev/zero.

swapon może nie działać poprawnie z plikami wymiany na niektórych wersjach btrfs. Jest to spowodowane tym, że brtfs jest systemem plików używającym kopiowania przy zapisie (copy-on-write): położenie pliku może nie być statyczny, co może prowadzić do uszkodzenia danych. System plików btrfs aktywnie nie pozwala na użycie plików wymiany, odmawiając przypisania (zmapowania) takiego pliku.

Jedynym możliwym obejściem tego problemu jest mapowanie pliku wymiany poprzez urządzenie loop. Pozwoli to systemowi plików poprawnie określić mapowanie, ale kosztem wydajności.

Swap poprzez NFS może nie działać.

Polecenie swapon automatycznie wykrywa i nadpisuje podpis przestrzeni wymiany ze starymi danymi wstrzymania (np. S1SUSPEND, S2SUSPEND, ...). Jest to konieczne, gdyż w przeciwnym wypadku nastąpiłoby uszkodzenie danych przy kolejnej próbie wybudzenia.

ŚRODOWISKO

LIBMOUNT_DEBUG=all
    włącza komunikaty debugowania biblioteki libmount

LIBBLKID_DEBUG=all
    włącza komunikaty debugowania biblioteki libblkid

ZOBACZ TAKŻE
swapon(2), swapoff(2), fstab(5), init(8), mkswap(8), rc(8), mount(8)

PLIKI
/dev/sd?? standardowe urządzenia stronicowania
/etc/fstab tablica opisująca systemy plików w ascii

HISTORIA
Polecenie swapon pojawiło się w 4.0BSD.

DOSTĘPNOŚĆ
Polecenie swapon jest częścią pakietu util-linux i jest dostępne pod adresem ftp://ftp.kernel.org/pub/linux/utils/util-linux/.

TŁUMACZENIE
Autorami polskiego tłumaczenia niniejszej strony podręcznika man są: Przemek Borys (PTM) <pborys@dione.ids.pl>, Michał Kułach <michal.kulach@gmail.com> i Robert Luberda <robert@debian.org>.

Polskie tłumaczenie jest częścią projektu manpages-pl; uwagi, pomoc, zgłaszanie błędów na stronie http://sourceforge.net/projects/manpages-pl/. Jest zgodne z wersją 2.28.2 oryginału.